/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// OperationRequestFormat - struct for OperationRequestFormat
type OperationRequestFormat struct {
	FormatRequest *FormatRequest
}

// FormatRequestAsOperationRequestFormat is a convenience function that returns FormatRequest wrapped in OperationRequestFormat
func FormatRequestAsOperationRequestFormat(v *FormatRequest) OperationRequestFormat {
	return OperationRequestFormat{
		FormatRequest: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *OperationRequestFormat) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FormatRequest
	err = newStrictDecoder(data).Decode(&dst.FormatRequest)
	if err == nil {
		jsonFormatRequest, _ := json.Marshal(dst.FormatRequest)
		if string(jsonFormatRequest) == "{}" { // empty struct
			dst.FormatRequest = nil
		} else {
			match++
		}
	} else {
		dst.FormatRequest = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FormatRequest = nil

		return fmt.Errorf("data matches more than one schema in oneOf(OperationRequestFormat)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(OperationRequestFormat)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src OperationRequestFormat) MarshalJSON() ([]byte, error) {
	if src.FormatRequest != nil {
		return json.Marshal(&src.FormatRequest)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *OperationRequestFormat) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FormatRequest != nil {
		return obj.FormatRequest
	}

	// all schemas are nil
	return nil
}

type NullableOperationRequestFormat struct {
	value *OperationRequestFormat
	isSet bool
}

func (v NullableOperationRequestFormat) Get() *OperationRequestFormat {
	return v.value
}

func (v *NullableOperationRequestFormat) Set(val *OperationRequestFormat) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationRequestFormat) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationRequestFormat) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationRequestFormat(val *OperationRequestFormat) *NullableOperationRequestFormat {
	return &NullableOperationRequestFormat{value: val, isSet: true}
}

func (v NullableOperationRequestFormat) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationRequestFormat) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
